﻿CREATE TABLE #tmpSplitStringSupplier
( 
	column1 VARCHAR(MAX)
)

CREATE TABLE #tmpSplitStringDock
( 
	column1 VARCHAR(MAX)
)

CREATE TABLE #tmpSplitStringManifest
( 
	column1 VARCHAR(MAX)
)

CREATE TABLE #manifestTemp
(
	manifestNo VARCHAR(30)
)

INSERT  INTO #tmpSplitStringSupplier(column1)
EXEC dbo.SplitString @0, ''

INSERT  INTO #tmpSplitStringDock(column1)
EXEC dbo.SplitString @1, ''

INSERT  INTO #tmpSplitStringManifest(column1)
EXEC dbo.SplitString @6, ''

	
	INSERT INTO #manifestTemp
	SELECT DISTINCT DOM.MANIFEST_NO
	FROM TB_R_DAILY_ORDER_MANIFEST AS DOM with(nolock)
	INNER JOIN dbo.TB_R_DAILY_ORDER_PART OP ON DOM.MANIFEST_NO = OP.MANIFEST_NO
	INNER JOIN TB_M_SUPPLIER S ON DOM.SUPPLIER_CD = S.SUPPLIER_CODE AND
			DOM.SUPPLIER_PLANT = S.SUPPLIER_PLANT_CD
	  WHERE DOM.ORDER_TYPE=@5 AND 
		(((DOM.[SUPPLIER_CD]+'-'+DOM.[SUPPLIER_PLANT]) IN(select column1 from #tmpSplitStringSupplier) AND isnull(@0,'') <> '') or (isnull(@0,'') = '')) AND 
		((DOM.[DOCK_CD] IN(select column1 from #tmpSplitStringDock) AND isnull(@1,'') <> '') or (isnull(@1,'') = '')) AND
		((DOM.MANIFEST_NO=@2 AND isnull(@2,'') <> '') or (isnull(@2,'') = '')) AND 
				((CONVERT(DATE,DOM.ORDER_RELEASE_DT,112) BETWEEN CAST(CONVERT(VARCHAR(8),CAST(@3 AS DATETIME),112) AS DATE) AND CAST(CONVERT(VARCHAR(8),CAST(@4 AS DATETIME),112) AS DATE))) AND
		((DOM.MANIFEST_NO IN(select column1 from #tmpSplitStringManifest) AND isnull(@6,'') <> '') or (isnull(@6,'') = '')) AND
		ISNULL(DOM.CANCEL_FLAG,'0') = '0'
		AND ((OP.PART_NO LIKE '%'+@7+'%' AND ISNULL(@7, '') <> '') OR (ISNULL(@7, '') = ''))
        AND (nullif(@9,'') is null OR eo_type = @9) 


IF(@8 = 'Build Out') --jika build_out_flag di TB_R_DAILY_ORDER_PART in (2, 3) maka sudah pasti build out, selain itu check dulu ke tb_m_part_bo
BEGIN
	SELECT DISTINCT DOM.MANIFEST_NO
				  ,DOM.ORDER_RELEASE_DT
				  ,DOM.ORDER_NO
				  ,DOM.DOCK_CD
				  ,DOM.SUPPLIER_CD
				  ,DOM.SUPPLIER_PLANT
				  ,DOM.TOTAL_QTY
				  ,DOM.PRINT_FLAG
				  ,S.SUPPLIER_NAME
				  ,DOM.ARRIVAL_PLAN_DT
				  ,RECEIVE_FLAG=ISNULL(DOM.RECEIVE_FLAG,'0')
				  ,FTP_FLAG=ISNULL(DOM.FTP_FLAG,'0')
				  ,DOWNLOAD_FLAG=ISNULL(DOM.DOWNLOAD_FLAG,'0')
				  ,DOM.DOWNLOADED_BY
				  ,DOM.DOWNLOADED_DT
                  ,DOM.EO_TYPE
                  ,DOM.CREATED_BY
                  ,DOM.CREATED_DT
                  ,DOM.CHANGED_BY
                  ,DOM.CHANGED_DT
	FROM TB_R_DAILY_ORDER_MANIFEST AS DOM with(nolock)
	INNER JOIN dbo.TB_R_DAILY_ORDER_PART OP ON DOM.MANIFEST_NO = OP.MANIFEST_NO
	INNER JOIN TB_M_SUPPLIER S ON DOM.SUPPLIER_CD = S.SUPPLIER_CODE AND
			DOM.SUPPLIER_PLANT = S.SUPPLIER_PLANT_CD
	WHERE EXISTS (SELECT '' FROM #manifestTemp mt WHERE mt.manifestNo = DOM.MANIFEST_NO)
		  AND
		  (
			ISNULL(OP.BUILD_OUT_FLAG, '') IN ('2' ,'3')
			OR
			EXISTS(SELECT '' FROM dbo.TB_M_PART_BO BO
												INNER JOIN dbo.TB_M_SUPPLIER SS ON SS.SUPPLIER_NAME = OP.SUPPLIER_NAME									
										 WHERE BO.PART_NO = OP.PART_NO AND BO.SUPPLIER_PLANT = OP.SUPPLIER_PLANT AND BO.DOCK_CD = OP.DOCK_CD AND SS.SUPPLIER_CODE = BO.SUPPLIER_CD
												AND BO.INACTIVE_FLAG = '0'
										       --AND ISNULL(OP.BUILD_OUT_FLAG, '') IN ('', '0', '1')
								)
		  )



END
ELSE IF(@8 = 'Reguler') --jika reguler, maka build_out_flag di tb_r_daily_order_part sama dengan in (null, '', 1) dan tidak ada di tb_m_part_bo
BEGIN
	SELECT DISTINCT DOM.MANIFEST_NO
				  ,DOM.ORDER_RELEASE_DT
				  ,DOM.ORDER_NO
				  ,DOM.DOCK_CD
				  ,DOM.SUPPLIER_CD
				  ,DOM.SUPPLIER_PLANT
				  ,DOM.TOTAL_QTY
				  ,DOM.PRINT_FLAG
				  ,S.SUPPLIER_NAME
				  ,DOM.ARRIVAL_PLAN_DT
				  ,RECEIVE_FLAG=ISNULL(DOM.RECEIVE_FLAG,'0')
				  ,FTP_FLAG=ISNULL(DOM.FTP_FLAG,'0')
				  ,DOWNLOAD_FLAG=ISNULL(DOM.DOWNLOAD_FLAG,'0')
				  ,DOM.DOWNLOADED_BY
				  ,DOM.DOWNLOADED_DT
                  ,DOM.EO_TYPE
                  ,DOM.CREATED_BY
                  ,DOM.CREATED_DT
                  ,DOM.CHANGED_BY
                  ,DOM.CHANGED_DT
	FROM TB_R_DAILY_ORDER_MANIFEST AS DOM with(nolock)
	INNER JOIN dbo.TB_R_DAILY_ORDER_PART OP ON DOM.MANIFEST_NO = OP.MANIFEST_NO
	INNER JOIN TB_M_SUPPLIER S ON DOM.SUPPLIER_CD = S.SUPPLIER_CODE AND
			DOM.SUPPLIER_PLANT = S.SUPPLIER_PLANT_CD
	WHERE EXISTS (SELECT '' FROM #manifestTemp mt WHERE mt.manifestNo = DOM.MANIFEST_NO)
		  AND
		  (
			ISNULL(OP.BUILD_OUT_FLAG, '') IN ('', '0', '1')
			AND
			NOT EXISTS(SELECT '' FROM dbo.TB_M_PART_BO BO
												INNER JOIN dbo.TB_M_SUPPLIER SS ON SS.SUPPLIER_NAME = OP.SUPPLIER_NAME									
										 WHERE BO.PART_NO = OP.PART_NO AND BO.SUPPLIER_PLANT = OP.SUPPLIER_PLANT AND BO.DOCK_CD = OP.DOCK_CD AND SS.SUPPLIER_CODE = BO.SUPPLIER_CD
										       AND BO.INACTIVE_FLAG = '0'
											   --AND ISNULL(OP.BUILD_OUT_FLAG, '') IN ('', '0', '1')
								)
		  )
END
ELSE
BEGIN
	SELECT DISTINCT DOM.MANIFEST_NO
				  ,DOM.ORDER_RELEASE_DT
				  ,DOM.ORDER_NO
				  ,DOM.DOCK_CD
				  ,DOM.SUPPLIER_CD
				  ,DOM.SUPPLIER_PLANT
				  ,DOM.TOTAL_QTY
				  ,DOM.PRINT_FLAG
				  ,S.SUPPLIER_NAME
				  ,DOM.ARRIVAL_PLAN_DT
				  ,RECEIVE_FLAG=ISNULL(DOM.RECEIVE_FLAG,'0')
				  ,FTP_FLAG=ISNULL(DOM.FTP_FLAG,'0')
				  ,DOWNLOAD_FLAG=ISNULL(DOM.DOWNLOAD_FLAG,'0')
				  ,DOM.DOWNLOADED_BY
				  ,DOM.DOWNLOADED_DT
                  ,DOM.EO_TYPE
                  ,DOM.CREATED_BY
                  ,DOM.CREATED_DT
                  ,DOM.CHANGED_BY
                  ,DOM.CHANGED_DT
	FROM TB_R_DAILY_ORDER_MANIFEST AS DOM with(nolock)
	INNER JOIN dbo.TB_R_DAILY_ORDER_PART OP ON DOM.MANIFEST_NO = OP.MANIFEST_NO
	INNER JOIN TB_M_SUPPLIER S ON DOM.SUPPLIER_CD = S.SUPPLIER_CODE AND
			DOM.SUPPLIER_PLANT = S.SUPPLIER_PLANT_CD
	WHERE EXISTS (SELECT '' FROM #manifestTemp mt WHERE mt.manifestNo = DOM.MANIFEST_NO)
END